'+-----------------------------------------------------------------------------+
'|                                                                             |
'| Autor: Jonas Eberhard   www.joseng.de                                       |
'| Datei: Dolly.bas                                                            |
'| Beschreibung:                                                               |
'|                                                                             |
'| Fuse Bits:  Low Byte: 0xFF           HighByte: 0xD9                         |
'|                                                                             |
'+-----------------------------------------------------------------------------+


'EEprombelegung
'+-----------------------------------------------------------------------------+
'|                                                                             |
'|                                                                             |
'|                                                                             |
'+-----------------------------------------------------------------------------+


'Mennummern
'+-----------------------------------------------------------------------------+
'|                                                                             |
'| 0: Hauptseite                                                               |
'| 1: Einstellungsmen                                                         |
'| 3: Fokuszeiteinstellung                                                     |
'| 4: Auslsezeit                                                              |
'| 5: Fahrmodus                                                                |
'|                                                                             |
'+-----------------------------------------------------------------------------+


'Positionen Hauptmen
'+-----------------------------------------------------------------------------+
'|                                                                             |
'| 1: Aus/An                                                                   |
'| 2: Wartezeit                                                                |
'| 3: Richtung                                                                 |
'| 4: Geschwindigkeit                                                          |
'|                                                                             |
'+-----------------------------------------------------------------------------+


'Positionen Einstellungsmen
'+-----------------------------------------------------------------------------+
'|                                                                             |
'| 1: Fokuszeit                                                                |
'| 2: Auslsezeit                                                              |
'| 3: Fahrmodus                                                                |
'| 4: Zurck (zum Hauptbildschirm)                                             |
'|                                                                             |
'+-----------------------------------------------------------------------------+


'Fahrmodus
'+-----------------------------------------------------------------------------+
'|                                                                             |
'| 1: Kontinuierlich                                                           |
'| 2: Move-Shot-Move                                                           |
'|                                                                             |
'+-----------------------------------------------------------------------------+


'Variable Aenderung
'+-----------------------------------------------------------------------------+
'|                                                                             |
'| Die Variable "Aenderung" wird bei jeder nderung eines Parameters erhht    |
'| wenn dies bei der nderung der Variable eingetragen wird.                   |
'| ber eine If Abfrage wird dann entschieden ab welchem Delta der             |
'| Parameter um einen anderen Wert erhht wird, z.B. normal 0,1, schnell 1.    |
'|                                                                             |
'| Mit einer Abfrage am Ende der Hauptschleife kann noch die Wartezeit         |
'| zwischen den nderungen beeinflusst werden.                                 |
'|                                                                             |
'| Hier ist es so, dass die Parameter sich bis Delta 10 um 0,1 ndern dann     |
'| ndern die sich um 1. Wenn nun ein Delta von 20 erricht wird, wird die      |
'| Wartezeit zwischen den nderungen von 200ms auf 50ms verkrzt.              |
'|                                                                             |
'+-----------------------------------------------------------------------------+



'Displayvorlage 2*16 Zeichen
'+----------------+
'|                |
'|                |
'+----------------+


'Umlaute auf Display
' -> chr(225)
' -> chr(239)
' -> chr(245)


$regfile = "m8def.dat"                                      'ATmega8
$crystal = 12000000                                         '12MHz Quarz

$hwstack = 40
$swstack = 8
$framesize = 16

Declare Function Sstellen(zahl As Single) As Byte
Declare Function Wstellen(zahl As Word) As Byte


'Timer2 (Im CTC Modus mit 100s Interrupt) fr die 100ms Takt
Tccr2 = &B00001010                                          'CTC Modus; Prescaler 8, keine Anbindung an den OC2 Pin
Ocr2 = 149
Assr = 0
Timsk = Timsk And 127
On Oc2 Isr_timer2


'Timer1 (Hardware PWM)
Config Timer1 = Pwm , Pwm = 8 , Prescale = 1 , Compare A Pwm = Clear Down , Compare B Pwm = Clear Down
Enable Timer1


'LCD
Config Lcdpin = Pin , Db4 = Portc.2 , Db5 = Portc.3 , Db6 = Portc.4 , Db7 = Portc.5 , E = Portc.1 , Rs = Portc.0
Config Lcd = 16 * 2


'Ein/Ausgnge festlegen
Config Portd.1 = Output                                     'Fokus
Config Portd.2 = Output                                     'Auslser

Config Portd.3 = Input                                      'Taste Enter
Config Portd.4 = Input                                      'Taste Rechts
Config Portd.5 = Input                                      'Taste Links
Config Portd.6 = Input                                      'Taste Hoch
Config Portd.7 = Input                                      'Taste Runter

Config Portb.1 = Output                                     'MotorPWM/Enable
Config Portb.4 = Output                                     'Motorrichtungspin 1
Config Portb.5 = Output                                     'Motorrichtungspin 2


'Aliasdeklarationen
Fokus Alias Portd.1                                         'Fokus
Ausloeser Alias Portd.2                                     'Auslser

Trunter Alias Pind.7                                        'Runter
Thoch Alias Pind.6                                          'Hoch
Tlinks Alias Pind.5                                         'Links
Trechts Alias Pind.4                                        'Rechts
Tenter Alias Pind.3                                         'Enter

Motorpwm Alias Pwm1a                                        'MotorPWM
Motorenable Alias Portb.4                                   'Enable
Motorrichtung Alias Portb.5                                 'Richtungspin


'PullUps setzten
Set Portd.7
Set Portd.6
Set Portd.5
Set Portd.4
Set Portd.3


'Deklarationen
Dim Aufnahmen As Word                                       'Gemachte Aufnahmen seit dem Start
Dim Wartezeit As Single                                     'Zeit zwischen den Aufnahmen
Dim Fokuszeit As Single                                     'Zeit zum Fokusieren
Dim Ausloesezeit As Single                                  'Zeit zum Auslsen
Dim Geschwindigkeit As Word                                 'Geschwindigkeit mit der gefahren wird in % (0-100%)
Dim Richtung As String * 1                                  'Fahrrichtung
Dim Modus As Byte                                           'Run oder Stop
Dim Position As Byte                                        'Position in Mens
Dim Menu As Byte                                            'Men (Hauptmen:0)
Dim Taste As Byte                                           'Gedrckte Taste
Dim Aenderung As Byte                                       'Hhe der nderung einer Variable
Dim Timercounter As Long                                    'Zhler fr Wartezeit in Timer
Dim Timerzeit As Single                                     'Errechneter Zhlwert fr Timer
Dim Timercounts As Long                                     'Zu errichende Counts fr den Timer fr das nchste Ereignis
Dim Timerevent As Byte                                      'Was im TimerISR geschehen soll
Dim Fahrmodus As Byte                                       'Gibt die Art der Fahrt an (Kontinuierlich, Move-Shot-Move)
Dim Smsleistung As Byte                                     'PWM des Motors im SMS Modus in %
Dim Smsfahrzeit As Single                                   'Fahrzeit im SMS Modus
Dim Maxaufnahmen As Word                                    'Max Anzahl Bilder die gemacht werden

Dim Fokuscounts As Long
Dim Ausloesecounts As Long
Dim Smsfahrzeitcounts As Long
Dim Timerzeitcounts As Long

Dim Sdummy As Single                                        'Rechenvariable Single
Dim Wdummy As Word                                          'Rechenvariable Word
Dim Bdummy As Byte                                          'Rechenvariable Byte
Dim Tdummy As String * 5                                    'Stringdummyvariable


'Interrupts freigeben (Timer und PWM)
Enable Interrupts                                           'Interrupts (Timer und externe) zulassen

'Startwerte der Variablen
Richtung = "R"                                              'Richtung
Fokuszeit = 1.0
Ausloesezeit = 1.0
Wartezeit = Fokuszeit + Ausloesezeit                        'Minimale Wartezeit ist die Summe von Fokuszeit + Auslsezeit
Geschwindigkeit = 0
Position = 1                                                'Startposition
Menu = 0                                                    'Hauptmen
Modus = 0                                                   'Stop
Fahrmodus = 1                                               'Kontinuierlich Fahren
Timerevent = 0                                              'Noch nichts passiert
Timercounts = 0                                             'Noch keine Zeit
Motorpwm = 0                                                'Motor aus
Smsleistung = 100                                           'Volle Leistung im SMS Modus
Smsfahrzeit = 1.0                                           'Fahrzeit im SMS Modus
Maxaufnahmen = 65000                                        'So ca die maximale Anzahl die berhaupt geht


'Richtung auch auf Hardware bertragen
Reset Motorenable
Reset Motorrichtung


'Display aufbauen
Cls                                                         'Dislpay lschen
Gosub Maindisplay
Locate 1 , 1                                                'Position = 1
Cursor On Blink


'Hauptschleife
Do
  'Tasten abfragen
  If Thoch = 0 Then                                         'Hoch
    Taste = 1
  Elseif Trunter = 0 Then                                   'Runter
    Taste = 2
  Elseif Taste = 0 And Tlinks = 0 Then                      'Links
    Taste = 3
  Elseif Taste = 0 And Trechts = 0 Then                     'Rechts
    Taste = 4
  Elseif Tenter = 0 Then                                    'Enter
    Taste = 5
  Else                                                      'Keine
    Taste = 0
    Aenderung = 0
  End If

  'Hauptmen
  If Menu = 0 Then
    If Modus = 1 Then
      Gosub Update_aufnahmen
    End If

    'Wenn Enter gedrckt wird zu Einstellungen springen
    If Taste = 5 And Modus = 0 Then
      Menu = 1
      Position = 1
      Taste = 0
      Gosub Update_einstellungen
    End If

    'Links,Rechts
    If Taste = 3 And Modus = 0 Then
      Decr Position
      If Position = 0 Then Position = 4
    Elseif Taste = 4 And Modus = 0 Then
      Incr Position
      If Position = 5 Then Position = 1
    End If

    'Menposition auswhlen
    If Position = 1 Then
      Locate 1 , 1
    Elseif Position = 2 Then
      Locate 1 , 15
    Elseif Position = 3 Then
      Locate 2 , 1
    Elseif Position = 4 Then
      Locate 2 , 6
    End If

    'Hoch,Runter
    If Taste = 1 Then
      If Position = 1 Then
        'Modus ndern
        Gosub Switch_modus
      Elseif Position = 2 Then
        'Wartezeit erhhen
        If Aenderung > 10 Then
          Wartezeit = Wartezeit + 1
        Else
          Wartezeit = Wartezeit + 0.1
        End If
        Incr Aenderung
        Gosub Update_wartezeit                              'Display aktualisieren
      Elseif Position = 3 Then
        'Richtung ndern
        Gosub Switch_richtung
      Elseif Position = 4 Then
        If Aenderung > 10 Then
          If Fahrmodus = 1 And Geschwindigkeit < 95 Then
            Geschwindigkeit = Geschwindigkeit + 5
          Elseif Fahrmodus = 2 And Smsfahrzeit < 10 Then
            Smsfahrzeit = Smsfahrzeit + 1
          End If
        Else
          If Fahrmodus = 1 And Geschwindigkeit < 100 Then
            Geschwindigkeit = Geschwindigkeit + 1
          Elseif Fahrmodus = 2 And Smsfahrzeit < 10 Then
            Smsfahrzeit = Smsfahrzeit + 0.1
          End If
        End If
        Incr Aenderung
        Gosub Update_richgesch                              'Display aktualisieren
      End If
    Elseif Taste = 2 Then
      Sdummy = Fokuszeit + Ausloesezeit                     'Minimale Wartezeit berechnen
      Sdummy = Sdummy + 0.1
      If Fahrmodus = 2 Then
        Sdummy = Sdummy + Smsfahrzeit
      End If
      If Position = 1 Then
        'Modus ndern
        Gosub Switch_modus
      Elseif Position = 2 And Wartezeit > Sdummy Then       'in Sdummy ist die Summe von Fokuszeit und Auslsezeit
        'Wartezeit verringern
        Sdummy = Sdummy + 1
        If Aenderung > 10 And Wartezeit > Sdummy Then
          Wartezeit = Wartezeit - 1
        Else
          Wartezeit = Wartezeit - 0.1
        End If
        Incr Aenderung
        Gosub Update_wartezeit                              'Display aktualisieren
      Elseif Position = 3 Then
        'Richtung ndern
        Gosub Switch_richtung
      Elseif Position = 4 Then
        If Aenderung > 10 Then
          If Fahrmodus = 1 And Geschwindigkeit > 5 Then
            Geschwindigkeit = Geschwindigkeit - 5
          Elseif Fahrmodus = 2 And Smsfahrzeit > 1 Then
            Smsfahrzeit = Smsfahrzeit - 1
          End If
        Else
          If Fahrmodus = 1 And Geschwindigkeit > 0 Then
            Geschwindigkeit = Geschwindigkeit - 1
          Elseif Fahrmodus = 2 And Smsfahrzeit > 0 Then
            Smsfahrzeit = Smsfahrzeit - 0.1
          End If
        End If
        Incr Aenderung
        Gosub Update_richgesch                              'Display aktualisieren
      End If
    End If
  End If

  'Einstellungen
  If Menu = 1 Then
    'Hoch/Runter -> Position im Men ndern und Cursor neu positionieren
    If Taste = 1 Then
      Decr Position
      If Position = 0 Then Position = 6
      'Men darstellen
      Gosub Update_einstellungen
    End If
    If Taste = 2 Then
      Incr Position
      If Position = 7 Then Position = 1
      'Men darstellen
      Gosub Update_einstellungen
    End If

    If Taste = 5 Then
      Cls
      Locate 1 , 1
      If Position = 1 Then                                  'Fokuszeit
        'Fokuszeit
        Menu = 3
        Lcd "Fokuszeit: "
        Locate 2 , 1
        Lcd Fusing(fokuszeit , "##.&") ; "s "
      Elseif Position = 2 Then                              'Auslsezeit
        'Auslsezeit
        Menu = 4
        Lcd "Ausl" ; Chr(239) ; "sezeit: "
        Locate 2 , 1
        Lcd Fusing(ausloesezeit , "##.&") ; "s "
      Elseif Position = 3 Then                              'Fahrmodus
        'Fahrmodus
        Menu = 5
        Lcd "Fahrmodus: "
        Locate 2 , 1
        'Ausgabe Fahrmodus
        Gosub Update_fahrmodus
      Elseif Position = 4 Then                              'SMS Motorleistung
        'SMS Motorleistung
        Menu = 6
        Lcd "SMS M.leistung"
        Locate 2 , 1
        Lcd Smsleistung ; "%"
      Elseif Position = 5 Then                              'Max Aufnahmen
        'Maximale Anzahl Aufnahmen
        Menu = 7
        Lcd "Max. Aufnahmen"
        Locate 2 , 1
        Lcd Maxaufnahmen
      Elseif Position = 6 Then                              'Zurck
        Menu = 0
        Position = 1
        Gosub Maindisplay
      End If
    End If
    Taste = 0
  End If

  'Fokuszeit
  If Menu = 3 Then
    Locate 2 , 1
    If Taste = 1 Then
      If Fokuszeit < 60 Then Fokuszeit = Fokuszeit + 0.1
      Lcd Fusing(fokuszeit , "##.&") ; "s "
    Elseif Taste = 2 Then
      If Fokuszeit > 0 Then Fokuszeit = Fokuszeit - 0.1
      Lcd Fusing(fokuszeit , "##.&") ; "s "
    Elseif Taste = 5 Then
      Menu = 1
      Gosub Update_einstellungen
    End If
  End If

  'Auslsezeit
  If Menu = 4 Then
    Locate 2 , 1
    If Taste = 1 Then
      If Ausloesezeit < 60 Then Ausloesezeit = Ausloesezeit + 0.1
      Lcd Fusing(ausloesezeit , "##.&") ; "s "
    Elseif Taste = 2 Then
      If Ausloesezeit > 0 Then Ausloesezeit = Ausloesezeit - 0.1
      Lcd Fusing(ausloesezeit , "##.&") ; "s "
    Elseif Taste = 5 Then
      Menu = 1
      Gosub Update_einstellungen
    End If
  End If

  'Fahrmodus
  If Menu = 5 Then
    Locate 2 , 1
    If Taste = 1 Then                                       'Hoch
      Incr Fahrmodus
      If Fahrmodus = 3 Then Fahrmodus = 1
      Gosub Update_fahrmodus
    Elseif Taste = 2 Then                                   'Runter
      Decr Fahrmodus
      If Fahrmodus = 0 Then Fahrmodus = 2
      Gosub Update_fahrmodus
    Elseif Taste = 5 Then                                   'Enter
      Menu = 1
      Gosub Update_einstellungen
    End If
  End If

  'SMS Motorleistung
  If Menu = 6 Then
    Locate 2 , 1
    If Taste = 1 Then
      If Smsleistung < 100 Then Smsleistung = Smsleistung + 1
      Lcd Smsleistung ; "% "
    Elseif Taste = 2 Then
      If Smsleistung > 0 Then Smsleistung = Smsleistung - 1
      Lcd Smsleistung ; "% "
    Elseif Taste = 5 Then
      Menu = 1
      Gosub Update_einstellungen
    End If
  End If

  'Max Kameraaufnahmen
  If Menu = 7 Then
    Locate 2 , 1
    If Taste = 1 Then
      If Maxaufnahmen < 65000 Then
        If Aenderung > 10 Then
          Maxaufnahmen = Maxaufnahmen + 50
        Else
          Maxaufnahmen = Maxaufnahmen + 1
        End If
        Incr Aenderung
      End If
      Lcd Maxaufnahmen ; "    "
    Elseif Taste = 2 Then
      If Maxaufnahmen > 0 Then
        If Aenderung > 10 Then
          If Maxaufnahmen > 70 Then
            Maxaufnahmen = Maxaufnahmen - 50
          End If
        Else
          Maxaufnahmen = Maxaufnahmen - 1
        End If
        Incr Aenderung
      End If
      Lcd Maxaufnahmen ; "    "
    Elseif Taste = 5 Then
      Menu = 1
      Gosub Update_einstellungen
    End If
  End If

  'Gedrckte Taste lschen und oben neu abfragen
  Taste = 0

  'Wenn die nderung weit genug, schneller ndern
  If Aenderung > 20 Then
    Waitms 80
    Aenderung = 21                                          'Aenderung gegen berlaufen begrenzen
  Else
    Waitms 200
  End If
Loop


'Timer2 fr die 100ms Takt (der Timer schlgt mit 100s zu -> Alle Zeiten [s] mal 10000 nehmen)
Isr_timer2:

  'Zhler erhhen
  Incr Timercounter

  'Timerwert erreicht?
  If Timercounter = Timercounts Then
    Timercounter = 0
    If Timerevent = 0 Then
      'Fokusieren
      Set Fokus
      Timercounts = Fokuscounts
      Incr Timerevent
    Elseif Timerevent = 1 Then
      'Auslsen
      Set Ausloeser
      Timercounts = Ausloesecounts
      Incr Timerevent
    Elseif Timerevent = 2 Then
      'Lschen
      Reset Ausloeser
      Reset Fokus
      'Aufnahmen erhhen
      Incr Aufnahmen
      'Gosub Update_aufnahmen

      If Fahrmodus = 2 Then
        'Verfahren
        Set Motorenable
        Timercounts = Smsfahrzeitcounts
        Incr Timerevent
      Else
        'Timer bis nchstes Bild einstellen
        Timercounts = Timerzeitcounts
        Timerevent = 0
      End If
    Elseif Timerevent = 3 Then
      'Motor wieder stoppen
      Reset Motorenable
      'Timer bis nchstes Bild einstellen
      Timercounts = Timerzeitcounts
      Timerevent = 0
    End If
  End If
Return


Maindisplay:
  'Diplay aufbauen
  '+----------------+
  '|Aus     xxxxx.xs|
  '|Rxxxcm/s [xxxxx]|
  '+----------------+

  Cls

  'Modus
  Locate 1 , 1                                              'Cursor links oben
  Lcd "Aus"

  'Wartezeit
  Gosub Update_wartezeit

  'Richtung, Geschwindigkeit
  Gosub Update_richgesch

  'Aufnahmen
  Gosub Update_aufnahmen
Return


Update_wartezeit:
  'Wartezeit
  Sdummy = Fokuszeit + Ausloesezeit                         'Minimale Wartezeit berechnen
  If Fahrmodus = 2 Then
    Sdummy = Sdummy + Smsfahrzeit
  End If
  If Wartezeit < Sdummy Then Wartezeit = Sdummy

  Bdummy = Sstellen(wartezeit)
  Bdummy = 11 - Bdummy
  Locate 1 , Bdummy
  Lcd "   " ; Fusing(wartezeit , "#####.&") ; "s"
Return


Update_richgesch:
  'Richtung, Geschwindigkeit/Fahrzeit
  Locate 2 , 1
  Lcd Richtung
  'Zahl lschen
  Locate 2 , 2
  Lcd "     "
  'Position berechnen
  If Fahrmodus = 1 Then
    'Wdummy = Geschwindigkeit
    'Bdummy = Wstellen(wdummy)
    Bdummy = Wstellen(geschwindigkeit)
    Bdummy = 7 - Bdummy
    Locate 2 , Bdummy
    Lcd Geschwindigkeit ; "% "
  Else
    Bdummy = Sstellen(smsfahrzeit)
    Bdummy = 7 - Bdummy
    Locate 2 , Bdummy
    Lcd Fusing(smsfahrzeit , "###.&") ; "s "
  End If
Return


Update_aufnahmen:
  'Aufnahmen
  'Position auswerten
  Bdummy = Wstellen(aufnahmen)
  Bdummy = 14 - Bdummy
  Locate 2 , Bdummy
  Lcd " [" ; Aufnahmen ; "]"
Return


Switch_modus:
  'Modus wechseln (Run/Stop)
  If Modus = 0 Then
    'Von der Wartezeit noch die Fokuier- und Auslsezeit abziehen -> Zeit zwischen den Bildern
    Timerzeit = Wartezeit - Fokuszeit
    Timerzeit = Timerzeit - Ausloesezeit
    If Fahrmodus = 2 Then
      Timerzeit = Timerzeit - Smsfahrzeit
    End If

    'Nur wenn die Zeit positiv ist
    'Wenn negativ, ist die Wartezeit zu klein
    If Timerzeit > 0 Then
      'Aufnahmen lschen
      Aufnahmen = 0
      Gosub Update_aufnahmen
      'Display
      Modus = 1
      Locate 1 , 1
      Lcd "An "

      'Motorgeschwindigkeit einstellen
      If Fahrmodus = 1 Then
        Sdummy = Geschwindigkeit * 2.55
      Else
        Sdummy = Smsleistung * 2.55
      End If
      Wdummy = Sdummy
      If Richtung = "L" Then
        Wdummy = 255 - Wdummy
      End If
      Motorpwm = Wdummy

      'Motor starten
      If Fahrmodus = 1 Then                                 'Kontinuierlich
        Set Motorenable
      'Elseif Fahrmodus = 2 Then                             'Shoot - Move - Shoot
      End If

      'Counterwerte vorberechnen
      Timerzeitcounts = Timerzeit * 10000
      Fokuscounts = Fokuszeit * 10000
      Ausloesecounts = Ausloesezeit * 10000
      Smsfahrzeitcounts = Smsfahrzeit * 10000

      'Timercounts & Timercounter = 0 dann wird beim ersten Zuschlagen des Timers gleich was ausgefhrt
      Timercounts = Timerzeitcounts
      Timercounter = 0
      Timerevent = 0

      'Timer starten (Interrupt freigeben)
      Timsk = Timsk Or 128
    End If
  Else
    Modus = 0
    Locate 1 , 1
    Lcd "Aus"
    'PhotoTimer stoppen
    Timsk = Timsk And 127
    'Motor stoppen (Interrupt sperren)
    Reset Motorenable
    Motorpwm = 0
  End If
  'Taste = 0
Return


Switch_richtung:
  'Richtung wechseln
  If Richtung = "R" Then
    Richtung = "L"
    'Die Richtung ist sowieso relativ, also ist der Zustand hier "relativ" egal, sollte nur das Gegenteil der anderen Richtung sein
    Set Motorrichtung
  Else
    Richtung = "R"
    'Pins setzten
    Reset Motorrichtung
  End If
  Lcd Richtung
Return


Update_einstellungen:
  'Men Einstellungen Eintrge anzeigen
  If Position = 1 Or Position = 2 Then
    Cls
    Locate 1 , 3
    Lcd "Fokuszeit"
    Locate 2 , 3
    Lcd "Ausl" ; Chr(239) ; "sezeit"
  Elseif Position = 3 Or Position = 4 Then
    Cls
    Locate 1 , 3
    Lcd "Fahrmodus"
    Locate 2 , 3
    Lcd "SMS M.leistung"
  Elseif Position = 5 Or Position = 6 Then
    Cls
    Locate 1 , 3
    Lcd "Max. Aufnahmen"
    Locate 2 , 3
    Lcd "Zur" ; Chr(245) ; "ck"
  End If

  'Zeiger anzeigen
  Bdummy = Position Mod 2
  If Bdummy = 0 Then
    Locate 2 , 1
  Else
    Locate 1 , 1
  End If
  Lcd ">"
Return


Update_fahrmodus:
  'Ausgabe Fahrmodus
  If Fahrmodus = 1 Then
    Lcd "Kontinuierlich"
  Elseif Fahrmodus = 2 Then
    Lcd "Move-Shot-Move"
  End If
Return


Function Sstellen(zahl As Single)
  'Position auswerten
  If Zahl >= 10000 Then
    Sstellen = 5
  Elseif Zahl >= 1000 Then
    Sstellen = 4
  Elseif Zahl >= 100 Then
    Sstellen = 3
  Elseif Zahl >= 10 Then
    Sstellen = 2
  Else
    Sstellen = 1
  End If
End Function


Function Wstellen(zahl As Word)
  'Position auswerten
  If Zahl >= 10000 Then
    Wstellen = 5
  Elseif Zahl >= 1000 Then
    Wstellen = 4
  Elseif Zahl >= 100 Then
    Wstellen = 3
  Elseif Zahl >= 10 Then
    Wstellen = 2
  Else
    Wstellen = 1
  End If
End Function