'+-----------------------------------------------------------------------------+
'|                                                                             |
'| Autor: Jonas Eberhard   www.joseng.de                                       |
'| Datei: Dolly.bas                                                            |
'| Beschreibung:                                                               |
'|                                                                             |
'| Fuse Bits:  Low Byte: 0xFF           HighByte: 0xD9                         |
'|                                                                             |
'+-----------------------------------------------------------------------------+


'Displayvorlage
'+----------------+
'|                |
'|                |
'+----------------+


$regfile = "m8def.dat"                                      'ATmega8
$crystal = 12000000                                         '12MHz Quarz

Declare Function Stellen(zahl As Single) As Byte


'Timer0 (Fahrtimer)   100kH
'Config Timer0 = Timer , Prescale = 1
'On Timer0 Isr_timer0
'Enable Timer0


'Timer1 (100ms)
Config Timer1 = Timer , Prescale = 64
On Timer1 Isr_timer1
Enable Timer1


'Timer2 (PWM 8bit) (16MHz / 1024 ~ 16kHz) Timer fr Motor
'Config Timer2 = Pwm , Pwm = On , Prescale = 1024 , Compare Pwm = Clear Down


'LCD
Config Lcdpin = Pin , Db4 = Portc.2 , Db5 = Portc.3 , Db6 = Portc.4 , Db7 = Portc.5 , E = Portc.1 , Rs = Portc.0
Config Lcd = 16 * 2


'Ein/Ausgnge festlegen
Config Portd.1 = Output                                     'Fokus
Config Portd.2 = Output                                     'Auslser

Config Portd.3 = Input                                      'Taste Enter
Config Portd.4 = Input                                      'Taste Rechts
Config Portd.5 = Input                                      'Taste Links
Config Portd.6 = Input                                      'Taste Hoch
Config Portd.7 = Input                                      'Taste Runter


'Aliasdeklarationen
Fokus Alias Portd.1                                         'Fokus
Ausloeser Alias Portd.2                                     'Auslser

Trunter Alias Pind.7                                        'Runter
Thoch Alias Pind.6                                          'Hoch
Tlinks Alias Pind.5                                         'Links
Trechts Alias Pind.4                                        'Rechts
Tenter Alias Pind.3                                         'Enter


'PullUps setzten
Set Portd.7
Set Portd.6
Set Portd.5
Set Portd.4
Set Portd.3


'Deklarationen
'Const Timervorgabe0 = 0                                               'Timer0
Const Timervorgabe1 = 40536                                           'Timer1
Dim Aufnahmen As Word                                                 'Gemachte Aufnahmen seit dem Start
Dim Wartezeit As Single                                               'Zeit zwischen den Aufnahmen
Dim Fokuszeit As Single                                               'Zeit zum Fokusieren
Dim Ausloesezeit As Single                                            'Zeit zum Auslsen
Dim Geschwindigkeit As Byte                                           'Geschwindigkeit mit der gefahren wird
Dim Richtung As String * 1                                            'Fahrrichtung
Dim Modus As Byte                                                     'Run oder Stop
Dim Position As Byte                                                  'Position in Mens
Dim Menu As Byte                                                      'Men (Hauptmen:0)
Dim Taste As Byte                                                     'Gedrckte Taste
Dim Aenderung As Byte                                                 'Hhe der nderung einer Variable
Dim Zaehler As Single                                                 'Zhler fr Wartezeit in Timer
Dim Timerzeit As Single

Dim Sdummy As Single                                                  'Rechenvariable Single
Dim Wdummy As Word                                                    'Rechenvariable Word
Dim Bdummy As Byte                                                    'Rechenvariable Byte



'Startwerte
'Timer0 = Timervorgabe0
Timer1 = Timervorgabe1
Stop Timer1
Enable Interrupts                                                     'Interrupts (Timer und externe) zulassen

'Pwm2 = 255                                                           'Geschwindigkeit auf 100%
Richtung = "R"                                                        'Richtung
Wartezeit = 0.0
Fokuszeit = 1.0
Ausloesezeit = 1.0
Position = 1                                                          'Startposition
Menu = 0                                                              'Hauptmen
Modus = 0                                                             'Stop

Cursor Off Noblink                                                    'Cursor nicht anzeigen
Cls                                                                   'Dislpay lschen
Display On                                                            'Display einschalten
Locate 1 , 1                                                          'Cursor links oben


'Display aufbauen
Gosub Maindisplay
Locate 1 , 1                                                          'Position = 1
Cursor On Blink

'Hauptschleife/Hauptmen
Do
  'Tasten abfragen
  If Thoch = 0 Then
    Taste = 1
  Elseif Trunter = 0 Then
    Taste = 2
  Elseif Taste = 0 And Tlinks = 0 Then
    Taste = 3
  Elseif Taste = 0 And Trechts = 0 Then
    Taste = 4
  Elseif Tenter = 0 Then
    Taste = 5
  Else
    Taste = 0
    Aenderung = 0
  End If

  'Hauptmen
  If Menu = 0 Then
    'Links,Rechts
    If Taste = 3 Then
      Decr Position
      If Menu = 0 And Position = 0 Then Position = 4
    End If
    If Taste = 4 Then
      Incr Position
      If Menu = 0 And Position = 5 Then Position = 1
    End If

    'Menposition auswhlen
    If Position = 1 Then
      Locate 1 , 1
    Elseif Position = 2 Then
      Locate 1 , 15
    Elseif Position = 3 Then
      Locate 2 , 1
    Elseif Position = 4 Then
      Locate 2 , 2
    End If

    'Hoch,Runter
    If Taste = 1 Then
      If Position = 1 Then
        'Modus ndern
        Gosub Switch_modus
      Elseif Position = 2 Then
        'Wartezeit erhhen
        If Aenderung > 10 Then
          Wartezeit = Wartezeit + 1
        Else
          Wartezeit = Wartezeit + 0.1
          Incr Aenderung
        End If
        Gosub Update_wartezeit                                        'Display aktualisieren
      Elseif Position = 3 Then
        'Richtung ndern
        Gosub Switch_richtung
      Elseif Position = 4 Then
          Geschwindigkeit = Geschwindigkeit + 1                       'Geschwindigkeit erhhen
          Incr Aenderung
          Gosub Update_richgesch                                      'Display aktualisieren
      End If
    Elseif Taste = 2 Then
      If Position = 1 Then
        'Modus ndern
        Gosub Switch_modus
      Elseif Position = 2 And Wartezeit > 0 Then
        'Wartezeit verringern
        If Aenderung > 10 Then
          Wartezeit = Wartezeit - 1
        Else
          Wartezeit = Wartezeit - 0.1
          Incr Aenderung
        End If
        If Wartezeit < 0 Then Wartezeit = 0
        Gosub Update_wartezeit                                        'Display aktualisieren
      Elseif Position = 3 Then
        'Richtung ndern
        Gosub Switch_richtung
      Elseif Position = 4 And Geschwindigkeit > 0 Then
          Geschwindigkeit = Geschwindigkeit - 1                       'Geschwindigkeit verringern
          Incr Aenderung
          Gosub Update_richgesch                                      'Display aktualisieren
      End If
    End If
  End If

  If Aenderung > 20 Then Aenderung = 20                               'Aenderung gegen berlaufen begrenzen
  If Aenderung > 10 Then
    Waitms 50
  Else
    Waitms 200
  End If
Loop


'Timer1 (100ms)
Isr_timer1:
  Timer1 = Timervorgabe1                                              'Timer neu laden

  'Zhler erhhen
  Incr Zaehler

  Locate 2 , 1
  Lcd Zaehler
  'Timerwert erreicht?
  If Zaehler = Timerzeit Then

    'Fokusieren
    Wdummy = Fokuszeit * 1000
    Set Fokus
    Waitms Wdummy

    'Auslsen
    Wdummy = Ausloesezeit * 1000
    Set Ausloeser
    Waitms Wdummy

    'Lschen
    Reset Ausloeser
    Reset Fokus

    'Aufnahmen erhhen
    Incr Aufnahmen
    Gosub Update_aufnahmen

    'Zhler zurcksetzten
    Zaehler = 0
  End If
Return


Maindisplay:
  'Diplay aufbauen
  '+----------------+
  '|Aus     xxxxx.xs|
  '|Rxxxcm/s [xxxxx]|
  '+----------------+

  'Modus
  Locate 1 , 1                                                        'Cursor links oben
  Lcd "Aus"

  'Wartezeit
  Gosub Update_wartezeit

  'Richtung, Geschwindigkeit
  Gosub Update_richgesch

  'Aufnahmen
  Gosub Update_aufnahmen
Return


Update_wartezeit:
  'Wartezeit
  Bdummy = Stellen(wartezeit)
  Bdummy = 11 - Bdummy
  Locate 1 , Bdummy
  Lcd "   " ; Fusing(wartezeit , "#####.&") ; "s"
Return


Update_richgesch:
  'Richtung, Geschwindigkeit
  Locate 2 , 1
  Lcd Richtung ; Geschwindigkeit ; "cm/s "
Return


Update_aufnahmen:
  'Aufnahmen
  'Position auswerten
  If Aufnahmen >= 10000 Then
    Bdummy = 5
  Elseif Aufnahmen >= 1000 Then
    Bdummy = 4
  Elseif Aufnahmen >= 100 Then
    Bdummy = 3
  Elseif Aufnahmen >= 10 Then
    Bdummy = 2
  Else
    Bdummy = 1
  End If
  Bdummy = 15 - Bdummy
  Locate 2 , Bdummy
  Lcd "[" ; Aufnahmen ; "]"
Return


Switch_modus:
  'Modus wechseln (Run/Stop)
  If Modus = 0 Then
    Modus = 1
    Lcd "An "
    'Timer starten
      'Die Wartezeit mal 10 nehmen wegen der 100ms
      'und die beiden Zeiten abziehen
      Timerzeit = Wartezeit - Fokuszeit
      Timerzeit = Timerzeit - Ausloesezeit
      Timerzeit = Timerzeit * 10
      Timerzeit = Fix(timerzeit)
      'Aufnahmen lschen
      Aufnahmen = 0
      Gosub Update_aufnahmen
      'Timer starten
      Start Timer1

      Locate 1 , 1
      Lcd Timerzeit
  Else
    Modus = 0
    Lcd "Aus"
    'Timer stoppen
    Stop Timer1
  End If
Return


Switch_richtung:
  'Richtung wechseln
  If Richtung = "R" Then
    Richtung = "L"
    Lcd "L"
  Else
    Richtung = "R"
    Lcd "R"
  End If
Return


Function Stellen(zahl As Single)
  'Position auswerten
  If Zahl >= 10000 Then
    Stellen = 5
  Elseif Zahl >= 1000 Then
    Stellen = 4
  Elseif Zahl >= 100 Then
    Stellen = 3
  Elseif Zahl >= 10 Then
    Stellen = 2
  Else
    Stellen = 1
  End If
End Function