'+-----------------------------------------------------------------------------+
'|                                                                             |
'| Autor: Jonas Eberhard   www.joseng.de                                       |
'| Datei: Dolly.bas                                                            |
'| Beschreibung:                                                               |
'|                                                                             |
'| Fuse Bits:  Low Byte: 0xFF           HighByte: 0xD9                         |
'|                                                                             |
'+-----------------------------------------------------------------------------+


'EEprombelegung
'+-----------------------------------------------------------------------------+
'|                                                                             |
'|                                                                             |
'|                                                                             |
'+-----------------------------------------------------------------------------+


'Mennummern
'+-----------------------------------------------------------------------------+
'|                                                                             |
'| 0: Hauptseite                                                               |
'| 1: Einstellungsmen                                                         |
'| 3: Fokuszeiteinstellung                                                     |
'| 4: Auslsezeit                                                              |
'| 5: Fahrmodus                                                                |
'|                                                                             |
'+-----------------------------------------------------------------------------+


'Positionen Hauptmen
'+-----------------------------------------------------------------------------+
'|                                                                             |
'| 1: Aus/An                                                                   |
'| 2: Wartezeit                                                                |
'| 3: Richtung                                                                 |
'| 4: Geschwindigkeit                                                          |
'|                                                                             |
'+-----------------------------------------------------------------------------+


'Positionen Einstellungsmen
'+-----------------------------------------------------------------------------+
'|                                                                             |
'| 1: Fokuszeit                                                                |
'| 2: Auslsezeit                                                              |
'| 3: Fahrmodus                                                                |
'| 4: Zurck (zum Hauptbildschirm)                                             |
'|                                                                             |
'+-----------------------------------------------------------------------------+


'Fahrmodus
'+-----------------------------------------------------------------------------+
'|                                                                             |
'| 1: Kontinuierlich                                                           |
'| 2: Move-Shot-Move                                                           |
'|                                                                             |
'+-----------------------------------------------------------------------------+


'Variable Aenderung
'+-----------------------------------------------------------------------------+
'|                                                                             |
'| Die Variable "Aenderung" wird bei jeder nderung eines Parameters erhht    |
'| wenn dies bei der nderung der Variable eingetragen wird.                   |
'| ber eine If Abfrage wird dann entschieden ab welchem Delta der             |
'| Parameter um einen anderen Wert erhht wird, z.B. normal 0,1, schnell 1.    |
'|                                                                             |
'| Mit einer Abfrage am Ende der Hauptschleife kann noch die Wartezeit         |
'| zwischen den nderungen beeinflusst werden.                                 |
'|                                                                             |
'| Hier ist es so, dass die Parameter sich bis Delta 10 um 0,1 ndern dann     |
'| ndern die sich um 1. Wenn nun ein Delta von 20 erricht wird, wird die      |
'| Wartezeit zwischen den nderungen von 200ms auf 50ms verkrzt.              |
'|                                                                             |
'+-----------------------------------------------------------------------------+



'Displayvorlage 2*16 Zeichen
'+----------------+
'|                |
'|                |
'+----------------+


'Umlaute auf Display
' -> chr(225)
' -> chr(239)
' -> chr(245)


$regfile = "m8def.dat"                                      'ATmega8
$crystal = 12000000                                         '12MHz Quarz

Declare Function Sstellen(zahl As Single) As Byte
Declare Function Wstellen(zahl As Word) As Byte



'Timer0 (PWM Timer)   100kH
'Config Timer0 = Timer , Prescale = 1
'On Timer0 Isr_timer0
'Enable Timer0


'Timer1 (100ms)
Config Timer1 = Timer , Prescale = 64
On Timer1 Isr_timer1
Enable Timer1


'LCD
Config Lcdpin = Pin , Db4 = Portc.2 , Db5 = Portc.3 , Db6 = Portc.4 , Db7 = Portc.5 , E = Portc.1 , Rs = Portc.0
Config Lcd = 16 * 2


'Ein/Ausgnge festlegen
Config Portd.1 = Output                                     'Fokus
Config Portd.2 = Output                                     'Auslser

Config Portd.3 = Input                                      'Taste Enter
Config Portd.4 = Input                                      'Taste Rechts
Config Portd.5 = Input                                      'Taste Links
Config Portd.6 = Input                                      'Taste Hoch
Config Portd.7 = Input                                      'Taste Runter

Config Portb.1 = Output                                     'MotorPWM/Enable
Config Portb.4 = Output                                     'Motorrichtungspin 1
Config Portb.5 = Output                                     'Motorrichtungspin 2


'Aliasdeklarationen
Fokus Alias Portd.1                                         'Fokus
Ausloeser Alias Portd.2                                     'Auslser

Trunter Alias Pind.7                                        'Runter
Thoch Alias Pind.6                                          'Hoch
Tlinks Alias Pind.5                                         'Links
Trechts Alias Pind.4                                        'Rechts
Tenter Alias Pind.3                                         'Enter

Motorpwm Alias Portb.1                                      'MotorPWM/Enable
Motorrichtung1 Alias Portb.4                                'Richtungspin1
Motorrichtung2 Alias Portb.5                                'Richtungpin2

'PullUps setzten
Set Portd.7
Set Portd.6
Set Portd.5
Set Portd.4
Set Portd.3


'Deklarationen
'Const Timervorgabe0 = 0                                               'Timer0
Const Timervorgabe1 = 46786                                 'Timer1
Dim Aufnahmen As Word                                       'Gemachte Aufnahmen seit dem Start
Dim Wartezeit As Single                                     'Zeit zwischen den Aufnahmen
Dim Fokuszeit As Single                                     'Zeit zum Fokusieren
Dim Ausloesezeit As Single                                  'Zeit zum Auslsen
Dim Geschwindigkeit As Single                               'Geschwindigkeit mit der gefahren wird
Dim Richtung As String * 1                                  'Fahrrichtung
Dim Modus As Byte                                           'Run oder Stop
Dim Position As Byte                                        'Position in Mens
Dim Menu As Byte                                            'Men (Hauptmen:0)
Dim Taste As Byte                                           'Gedrckte Taste
Dim Aenderung As Byte                                       'Hhe der nderung einer Variable
Dim Zaehler As Single                                       'Zhler fr Wartezeit in Timer
Dim Timerzeit As Single                                     'Errechneter Zhlwert fr Timer
Dim Timercounts As Single                                   'Zu errichende Counts fr den Timer fr das nchste Ereignis
Dim Timerevent As Byte                                      'Was im TimerISR geschehen soll
Dim Pwmcounter As Byte                                      'Zhlvariable fr SoftPWM
Dim Pwmstufe As Byte                                        'Errechnete PWM fr die gewhlte Geschwindigkeit
Dim Fahrmodus As Byte                                       'Gibt die Art der Fahrt an (Kontinuierlich, Move-Shot-Move)
Dim Pwm As Byte                                             'Wert fr PWM

Dim Sdummy As Single                                        'Rechenvariable Single
Dim Wdummy As Word                                          'Rechenvariable Word
Dim Bdummy As Byte                                          'Rechenvariable Byte
Dim Tdummy As String * 5                                    'Stringdummyvariable


'Startwerte
'Timer0 = Timervorgabe0
Timer1 = Timervorgabe1
Stop Timer1
Enable Interrupts                                           'Interrupts (Timer und externe) zulassen

Richtung = "R"                                              'Richtung
Fokuszeit = 1.0
Ausloesezeit = 1.0
Wartezeit = Fokuszeit + Ausloesezeit                        'Minimale Wartezeit ist die Summe von Fokuszeit + Auslsezeit
Position = 1                                                'Startposition
Menu = 0                                                    'Hauptmen
Modus = 0                                                   'Stop
Fahrmodus = 1                                               'Kontinuierlich Fahren
Timerevent = 0                                              'Noch nichts passiert
Timercounts = 0                                             'Noch keine Zeit
Pwm = 0                                                     'Motor aus


'Display initialisieren
Cursor Off Noblink                                          'Cursor nicht anzeigen
Cls                                                         'Dislpay lschen
Display On                                                  'Display einschalten
Locate 1 , 1                                                'Cursor links oben


'Display aufbauen
Gosub Maindisplay
Locate 1 , 1                                                'Position = 1
Cursor On Blink


'Hauptschleife
Do
  'Tasten abfragen
  If Thoch = 0 Then                                         'Hoch
    Taste = 1
  Elseif Trunter = 0 Then                                   'Runter
    Taste = 2
  Elseif Taste = 0 And Tlinks = 0 Then                      'Links
    Taste = 3
  Elseif Taste = 0 And Trechts = 0 Then                     'Rechts
    Taste = 4
  Elseif Tenter = 0 Then                                    'Enter
    Taste = 5
  Else                                                      'Keine
    Taste = 0
    Aenderung = 0
  End If

  'Hauptmen
  If Menu = 0 Then
    'Wenn Enter gedrckt wird zu Einstellungen springen
    If Taste = 5 Then
      Menu = 1
      Position = 1
      Taste = 0
      Gosub Update_einstellungen
    End If

    'Links,Rechts
    If Taste = 3 Then
      Decr Position
      If Menu = 0 And Position = 0 Then Position = 4
    End If
    If Taste = 4 Then
      Incr Position
      If Menu = 0 And Position = 5 Then Position = 1
    End If

    'Menposition auswhlen
    If Position = 1 Then
      Locate 1 , 1
    Elseif Position = 2 Then
      Locate 1 , 15
    Elseif Position = 3 Then
      Locate 2 , 1
    Elseif Position = 4 Then
      Locate 2 , 4
    End If

    'Hoch,Runter
    If Taste = 1 Then
      If Position = 1 Then
        'Modus ndern
        Gosub Switch_modus
      Elseif Position = 2 Then
        'Wartezeit erhhen
        If Aenderung > 10 Then
          Wartezeit = Wartezeit + 1
        Else
          Wartezeit = Wartezeit + 0.1
        End If
        Incr Aenderung
        Gosub Update_wartezeit                              'Display aktualisieren
      Elseif Position = 3 Then
        'Richtung ndern
        Gosub Switch_richtung
      Elseif Position = 4 Then
        If Aenderung > 10 Then
          Geschwindigkeit = Geschwindigkeit + 1
        Else
          Geschwindigkeit = Geschwindigkeit + 0.1
        End If
        Incr Aenderung
        Gosub Update_richgesch                              'Display aktualisieren
      End If
    Elseif Taste = 2 Then
      Sdummy = Fokuszeit + Ausloesezeit                     'Minimale Wartezeit berechnen
      If Position = 1 Then
        'Modus ndern
        Gosub Switch_modus
      Elseif Position = 2 And Wartezeit > 0 And Wartezeit > Sdummy Then       'in Sdummy ist die Summy von Fokuszeit und Auslsezeit
        'Wartezeit verringern
        If Aenderung > 10 Then
          Wartezeit = Wartezeit - 1
        Else
          Wartezeit = Wartezeit - 0.1
        End If
        Incr Aenderung
        If Wartezeit < 0 Then Wartezeit = 0
        Gosub Update_wartezeit                              'Display aktualisieren
      Elseif Position = 3 Then
        'Richtung ndern
        Gosub Switch_richtung
      Elseif Position = 4 And Geschwindigkeit > 0 Then
        If Aenderung > 10 Then
          Geschwindigkeit = Geschwindigkeit - 1
        Else
          Geschwindigkeit = Geschwindigkeit - 0.1
        End If
        Incr Aenderung
        Gosub Update_richgesch                              'Display aktualisieren
      End If
    End If
  End If

  'Einstellungen
  If Menu = 1 Then
    'Hoch/Runter -> Position im Men ndern und Cursor neu positionieren
    If Taste = 1 Then
      Decr Position
      If Position = 0 Then Position = 4
      'Men darstellen
      Gosub Update_einstellungen
    End If
    If Taste = 2 Then
      Incr Position
      If Position = 5 Then Position = 1
      'Men darstellen
      Gosub Update_einstellungen
    End If

    If Taste = 5 Then
      Cls
      Locate 1 , 1
      If Position = 1 Then                                  'Fokuszeit
        'Fokuszeit
        Menu = 3
        Lcd "Fokuszeit: "
        Locate 2 , 1
        Lcd Fusing(fokuszeit , "#####.&") ; "s "
      Elseif Position = 2 Then                              'Auslsezeit
        'Auslsezeit
        Menu = 4
        Lcd "Ausl" ; Chr(239) ; "sezeit: "
        Locate 2 , 1
        Lcd Fusing(ausloesezeit , "#####.&") ; "s "
      Elseif Position = 3 Then                              'Fahrmodus
        'Fahrmodus
        Menu = 5
        Lcd "Fahrmodus: "
        Locate 2 , 1
        'Ausgabe Fahrmodus
        Gosub Update_fahrmodus
      Elseif Position = 4 Then                              'Zurck
        Menu = 0
        Position = 1
        Gosub Maindisplay
      End If
      Taste = 0
    End If
  End If

  'Fokuszeit
  If Menu = 3 Then
    Locate 2 , 1
    If Taste = 1 Then
      If Fokuszeit < 60 Then Fokuszeit = Fokuszeit + 0.1
      Lcd Fusing(fokuszeit , "#####.&") ; "s "
    Elseif Taste = 2 Then
      If Fokuszeit > 0 Then Fokuszeit = Fokuszeit - 0.1
      Lcd Fusing(fokuszeit , "#####.&") ; "s "
    Elseif Taste = 5 Then
      Menu = 1
      Gosub Update_einstellungen
      Taste = 0
    End If
  End If

  'Auslsezeit
  If Menu = 4 Then
    Locate 2 , 1
    If Taste = 1 Then
      If Ausloesezeit < 60 Then Ausloesezeit = Ausloesezeit + 0.1
      Lcd Fusing(ausloesezeit , "#####.&") ; "s "
    Elseif Taste = 2 Then
      If Ausloesezeit > 0 Then Ausloesezeit = Ausloesezeit - 0.1
      Lcd Fusing(ausloesezeit , "#####.&") ; "s "
    Elseif Taste = 5 Then
      Menu = 1
      Gosub Update_einstellungen
      Taste = 0
    End If
  End If

  'Fahrmodus
  If Menu = 5 Then
    Locate 2 , 1
    If Taste = 1 Then                                       'Hoch
      Incr Fahrmodus
      If Fahrmodus = 3 Then Fahrmodus = 1
      Gosub Update_fahrmodus
    Elseif Taste = 2 Then                                   'Runter
      Decr Fahrmodus
      If Fahrmodus = 0 Then Fahrmodus = 2
    Elseif Taste = 5 Then                                   'Enter
      Menu = 1
      Gosub Update_einstellungen
      Taste = 0
    End If
  End If

  If Aenderung > 30 Then Aenderung = 30                     'Aenderung gegen berlaufen begrenzen
  'Wenn die nderung weit genug, schneller ndern
  If Aenderung > 20 Then
    Waitms 50
  Else
    Waitms 200
  End If
Loop


'Timer0 (100kH) PWM
Isr_timer0:
  'SoftPWM

  'Zhler erhhen
  Incr Pwmcounter

  If Pwmcounter <= Pwm Then
    'Pin lschen
    Set Motorpwm
  Else
    Reset Motorpwm
  End If

  'Wenn PWMStufe = 0 und Pwmcounter bei 1 startet wird der Pin niemals gesetzt -> also PWM ist aus
  If Pwmcounter > 100 Then Pwmcounter = 1
Return


'Timer1 (100ms)
Isr_timer1:
  Timer1 = Timervorgabe1                                    'Timer neu laden

  'Zhler erhhen
  Incr Zaehler

  'Timerwert erreicht?
  If Zaehler = Timercounts Then
    If Timerevent = 0 Then
      'Modus Shot-Move-Shot?
      If Fahrmodus = 2 Then
        'Motor anhalten
        Pwmstufe = 0
      End If
      'Fokusieren
      Set Fokus
      Timercounts = Fokuszeit * 10
      Timerevent = 1
      Zaehler = 0
    Elseif Timerevent = 1 Then
      'Auslsen
      Set Ausloeser
      Timercounts = Ausloesezeit * 10
      Timerevent = 2
      Zaehler = 0
    Elseif Timerevent = 2 Then
      'Lschen
      Reset Ausloeser
      Reset Fokus
      'Aufnahmen erhhen
      Incr Aufnahmen
      Gosub Update_aufnahmen
      Timerevent = 0
      Timercounts = Timerzeit
      Zaehler = 0
      'Modus Shot-Move-Shot?
      If Fahrmodus = 2 Then
        'Motor weiter fahren lassen
        Pwm = Pwmstufe
      End If
    End If
  End If
Return


Maindisplay:
  'Diplay aufbauen
  '+----------------+
  '|Aus     xxxxx.xs|
  '|Rxxxcm/s [xxxxx]|
  '+----------------+

  'Modus
  Locate 1 , 1                                              'Cursor links oben
  Lcd "Aus"

  'Wartezeit
  Gosub Update_wartezeit

  'Richtung, Geschwindigkeit
  Gosub Update_richgesch

  'Aufnahmen
  Gosub Update_aufnahmen
Return


Update_wartezeit:
  'Wartezeit
  Bdummy = Sstellen(wartezeit)
  Bdummy = 11 - Bdummy
  Locate 1 , Bdummy
  Lcd "   " ; Fusing(wartezeit , "#####.&") ; "s"
Return


Update_richgesch:
  'Richtung, Geschwindigkeit
  Locate 2 , 1
  Lcd Richtung
  'Zahl lschen
  Locate 2 , 2
  Lcd "   "
  'Position berechnen
  Bdummy = Sstellen(geschwindigkeit)
  Bdummy = 5 - Bdummy
  Locate 2 , Bdummy
  Lcd Fusing(geschwindigkeit , "###.&") ; "cm/s "
  'Hardware setzten, Pins fr Richtung an H-Brcke
  If Richtung = "L" Then
    Set Motorrichtung1
    Reset Motorrichtung2
  Else
    Reset Motorrichtung1
    Set Motorrichtung2
  End If
Return


Update_aufnahmen:
  'Aufnahmen
  'Position auswerten
  Bdummy = Wstellen(aufnahmen)
  Bdummy = 14 - Bdummy
  Locate 2 , Bdummy
  Lcd " [" ; Aufnahmen ; "]"
Return


Switch_modus:
  'Modus wechseln (Run/Stop)
  If Modus = 0 Then
    'Die Wartezeit mal 10 nehmen wegen der 100ms
    'und die beiden Zeiten abziehen
    Timerzeit = Wartezeit - Fokuszeit
    Timerzeit = Timerzeit - Ausloesezeit
    Timerzeit = Timerzeit * 10
    Timerzeit = Fix(timerzeit)

    'Nur wenn die Zeit positiv ist
    'Wenn negativ, ist die Wartezeit zu klein
    If Timerzeit > 0 Then
      'Aufnahmen lschen
      Aufnahmen = 0
      Gosub Update_aufnahmen
      'Display
      Modus = 1
      Locate 1 , 1
      Lcd "An "

      'PhotoTimer starten
      Timercounts = Timerzeit
      Start Timer1

      'PWM starten
      'Hier muss noch die Umrechnung von ca. cm-Ma auf PWMStufe rein (ausprobieren) ---------------------------------------------------------
      'Errechnete PWM fr die gewhlte Geschwindigkeit speichern
      'Pwmstufe = Geschwindigkeit * 17.8 (Fr Getriebemotor mit 28 Zhne Riemenrad) (100% / 5,6cm pro Umdrehung)
      'Pwm = Pwmstufe
    Else
      Timerzeit = 0
    End If
  Else
    Modus = 0
    Locate 1 , 1
    Lcd "Aus"
    'PhotoTimer stoppen
    Stop Timer1
    Timerzeit = 0
    'PWM stoppen
    Pwmstufe = 0
  End If
  Taste = 0
Return


Switch_richtung:
  'Richtung wechseln
  If Richtung = "R" Then
    Richtung = "L"
  Else
    Richtung = "R"
  End If
  Lcd Richtung
Return


Update_einstellungen:
  'Men Einstellungen Eintrge anzeigen
  If Position = 1 Or Position = 2 Then
    Cls
    Locate 1 , 3
    Lcd "Fokuszeit"
    Locate 2 , 3
    Lcd "Ausl" ; Chr(239) ; "sezeit"
  Elseif Position = 3 Or Position = 4 Then
    Cls
    Locate 1 , 3
    Lcd "Fahrmodus"
    Locate 2 , 3
    Lcd "Zur" ; Chr(245) ; "ck"
  End If

  'Zeiger anzeigen
  Bdummy = Position Mod 2
  If Bdummy = 0 Then
    Locate 2 , 1
  Else
    Locate 1 , 1
  End If
  Lcd ">"
Return


Update_fahrmodus:
  'Ausgabe Fahrmodus
  If Fahrmodus = 1 Then
    Lcd "Kontinuierlich"
  Elseif Fahrmodus = 2 Then
    Lcd "Move-Shot-Move"
  End If
Return


Function Sstellen(zahl As Single)
  'Position auswerten
  If Zahl >= 10000 Then
    Sstellen = 5
  Elseif Zahl >= 1000 Then
    Sstellen = 4
  Elseif Zahl >= 100 Then
    Sstellen = 3
  Elseif Zahl >= 10 Then
    Sstellen = 2
  Else
    Sstellen = 1
  End If
End Function


Function Wstellen(zahl As Word)
  'Position auswerten
  If Zahl >= 10000 Then
    Wstellen = 5
  Elseif Zahl >= 1000 Then
    Wstellen = 4
  Elseif Zahl >= 100 Then
    Wstellen = 3
  Elseif Zahl >= 10 Then
    Wstellen = 2
  Else
    Wstellen = 1
  End If
End Function